MMDAI
=====

MMDAI is a fork project of MMDAgent (http://www.mmdagent.jp) to support cross platform

## これは何?

MMDAI とは MMDAgent からフォークしたプロジェクトです。
主な目的はクロスプラットフォームで動かせるようにすることです。

名前にあるとおり MMD (MikuMikuDance) で使われているモデルやモーションの読み込みが可能で、
かつ音声認識を行ってモデルと対話することが出来る点が特徴です。あくまで MMD 互換であり、
完全に同じ結果になることは全く保証されていません。

姉妹プロジェクトとして音声認識機能を持っていない代わりにモーション編集に対応した MMDAI2 と
MMDAI/MMDAI2 両方で用いられる OS に依存しない小型ライブラリである libvpvl があります。

## サポートされている OS

以下は開発で動作の確認が出来ている環境です。

  - Windows XP (MSVC 9.0) 32bit
    - Windows 8 Developer Preview 32bit
  - MacOSX 10.7 64bit
  - Fedora 15 64bit

## 使い方

※以下の説明は MMDAI (MMDAI2 ではない) のものになります。

MMDAgent 公式ページからスクリプトのパッケージをダウンロードし、拡張子 fst とつくファイルを
アプリケーションにドラッグ・アンド・ドロップするか、もしくはメニューから「ファイル」
「スクリプトの読み込み」で拡張子 fst のつくファイルを読みこむことでメイと対話可能になります。

MMDAI では実行バイナリを提供しているだけであり、スクリプトは提供していませんが、
単体でもメニューからモデルの読み込みやモーションの読み込みが可能です。
(MMDAgent でもドラッグ・アンド・ドロップからなら可能)

### メニューからの操作

キーボード、マウス、及びドラッグアンドドロップの操作は基本的にここでも可能です。
メニューから操作する場合、以下の機能を提供しています。

  - スクリプトの読み込み
  - モデルの読み込み及び削除
  - モーションの読み込み
  - カメラモーションの読み込み
  - 場面の再生、一時停止、停止
  - 場面の操作
  
### キーボードでの操作

  - CTRL + ↑
    - カメラビューを上に回転
  - CTRL + ↓
    - カメラビューを下に回転
  - CTRL + ←
    - カメラビューを左に回転
  - CTRL + →
    - カメラビューを右に回転
  - SHIFT + ↑
    - カメラビューを上に移動
  - SHIFT + ↓
    - カメラビューを下に移動
  - SHIFT + ←
    - カメラビューを左に移動
  - SHIFT + →
    - カメラビュー右に移動
  - ALT + ? or ALT + /
    - アプリケーションについてのダイアログの表示
  - +
    - カメラビューの拡大
  - -
    - カメラビューの縮小

### マウスを使った操作

  - ドラッグ
    - カメラビューの回転
  - SHIFT を押しながらのドラッグ
    - カメラビューの平行移動
  - ホイール操作
    - 視野距離の調整
  - CTRL を押しながらホイール操作
    - 視野距離の調整が高速になる
  - SHIFT を押しながらホイール操作
    - 視野距離の調整が高速になる
  - CTRL + SHIFT を押しながらのホイール操作
    - 視野角の調整
  - SHIFT + CTRL を押しながらのドラッグ
    - 光源の移動

### ドラッグ and ドロップ

  - PMD ファイル
    - モデルを追加
  - VMD ファイル
    - 選択されたモデルに対してモーションを追加
  - FST ファイル
    - スクリプトの読み込み

## 名前の由来

MMDAgent をぼかした名前の結果 MMDAI になっています。"AI" には特にこれといった略称はありません。
内部的に使用している名前である QMA は元々 "Qt MMD Agent" から名前をとっています。

MMDAI2 にはまだ使っていないものの別名があり、VPVM (VOCALOID Promotion Video Maker) といいます。
VPVL も元は VOCALOID Promotion Video Library の略名ですが完全名で使うことはないでしょう。
これらは MMD を配布しているサイト名である VPVP (VOCALOID Promotion Video Project) からとっています。

## ライセンス

MMDAgent と同じく修正 BSD ライセンスの下で配布されています。LICENSE を参照してください。
これは MMDAI だけでなく、MMDAI2 及び libvpvl も同様です。

ただし MMDAI/MMDAI2 は Qt を必要とするため、MMDAI/MMDAI2 を元に改造して派生品として作成しかつ利用規約に
リバースエンジニアリングをも禁止して配布したい場合は Qt の商用ライセンスを購入する必要があります。
開発ではなく単純に利用するだけならもちろん無料で利用可能です。

## 開発者

AUTHORS を参照してください

